let imports = {};
let wasm;

let cachedFloat64Memory0 = new Float64Array();

function getFloat64Memory0() {
    if (cachedFloat64Memory0.byteLength === 0) {
        cachedFloat64Memory0 = new Float64Array(wasm.memory.buffer);
    }
    return cachedFloat64Memory0;
}

let WASM_VECTOR_LEN = 0;

function passArrayF64ToWasm0(arg, malloc) {
    const ptr = malloc(arg.length * 8);
    getFloat64Memory0().set(arg, ptr / 8);
    WASM_VECTOR_LEN = arg.length;
    return ptr;
}
/**
* @param {Float64Array} numbers
* @returns {number}
*/
module.exports.average = function(numbers) {
    const ptr0 = passArrayF64ToWasm0(numbers, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.average(ptr0, len0);
    return ret;
};

/**
* @param {number} value
* @returns {number}
*/
module.exports.get_decimal_length = function(value) {
    const ret = wasm.get_decimal_length(value);
    return ret >>> 0;
};

/**
* @param {number} x
* @returns {number}
*/
module.exports.factorial = function(x) {
    const ret = wasm.factorial(x);
    return ret;
};

const u32CvtShim = new Uint32Array(2);

const int64CvtShim = new BigInt64Array(u32CvtShim.buffer);

let cachedInt32Memory0 = new Int32Array();

function getInt32Memory0() {
    if (cachedInt32Memory0.byteLength === 0) {
        cachedInt32Memory0 = new Int32Array(wasm.memory.buffer);
    }
    return cachedInt32Memory0;
}
/**
* @param {bigint} a
* @param {bigint} b
* @returns {bigint}
*/
module.exports.gcd = function(a, b) {
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        int64CvtShim[0] = a;
        const low0 = u32CvtShim[0];
        const high0 = u32CvtShim[1];
        int64CvtShim[0] = b;
        const low1 = u32CvtShim[0];
        const high1 = u32CvtShim[1];
        wasm.gcd(retptr, low0, high0, low1, high1);
        var r0 = getInt32Memory0()[retptr / 4 + 0];
        var r1 = getInt32Memory0()[retptr / 4 + 1];
        u32CvtShim[0] = r0;
        u32CvtShim[1] = r1;
        const n2 = int64CvtShim[0];
        return n2;
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
    }
};

/**
* @param {number} n
* @param {number} r
* @returns {number}
*/
module.exports.ncr = function(n, r) {
    const ret = wasm.ncr(n, r);
    return ret;
};

/**
* @param {number} n
* @param {number} r
* @returns {number}
*/
module.exports.npr = function(n, r) {
    const ret = wasm.npr(n, r);
    return ret;
};

const path = require('path').join(__dirname, 'umt_plugin_wasm_bg.wasm');
const bytes = require('fs').readFileSync(path);

const wasmModule = new WebAssembly.Module(bytes);
const wasmInstance = new WebAssembly.Instance(wasmModule, imports);
wasm = wasmInstance.exports;
module.exports.__wasm = wasm;

